]> git.ipfire.org Git - thirdparty/git.git/blame - git-sh-setup.sh
t4034: abstract away SHA-1-specific constants
[thirdparty/git.git] / git-sh-setup.sh
CommitLineData
11d62145
JN
1# This shell scriplet is meant to be included by other shell scripts
2# to set up some variables pointing at the normal git directories and
3# a few helper shell functions.
b33e9666 4
365527ad 5# Having this variable in your environment would break scripts because
e598c517 6# you would cause "cd" to be taken to unexpected places. If you
365527ad
JH
7# like CDPATH, define it for your interactive shell sessions without
8# exporting it.
785063e0 9# But we protect ourselves from such a user mistake nevertheless.
365527ad
JH
10unset CDPATH
11
393050c3
JH
12# Similarly for IFS, but some shells (e.g. FreeBSD 7.2) are buggy and
13# do not equate an unset IFS with IFS with the default, so here is
14# an explicit SP HT LF.
15IFS='
16'
785063e0 17
61dbb3c4
JH
18git_broken_path_fix () {
19 case ":$PATH:" in
20 *:$1:*) : ok ;;
21 *)
22 PATH=$(
23 SANE_TOOL_PATH="$1"
24 IFS=: path= sep=
25 set x $PATH
26 shift
27 for elem
28 do
29 case "$SANE_TOOL_PATH:$elem" in
30 (?*:/bin | ?*:/usr/bin)
31 path="$path$sep$SANE_TOOL_PATH"
32 sep=:
33 SANE_TOOL_PATH=
34 esac
35 path="$path$sep$elem"
36 sep=:
37 done
38 echo "$path"
39 )
40 ;;
41 esac
42}
43
44# @@BROKEN_PATH_FIX@@
0e0aea5a 45
1073094f
AK
46# Source git-sh-i18n for gettext support.
47. "$(git --exec-path)/git-sh-i18n"
48
adb231cf
FG
49die () {
50 die_with_status 1 "$@"
51}
52
53die_with_status () {
54 status=$1
55 shift
89b0230a 56 printf >&2 '%s\n' "$*"
adb231cf 57 exit "$status"
b33e9666
LT
58}
59
e064c170
SB
60GIT_QUIET=
61
62say () {
63 if test -z "$GIT_QUIET"
64 then
65 printf '%s\n' "$*"
66 fi
67}
68
bac199b7
PH
69if test -n "$OPTIONS_SPEC"; then
70 usage() {
5d292756
JH
71 "$0" -h
72 exit 1
bac199b7
PH
73 }
74
e817e3e8
PH
75 parseopt_extra=
76 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
77 parseopt_extra="--keep-dashdash"
51ba8ce3
NV
78 [ -n "$OPTIONS_STUCKLONG" ] &&
79 parseopt_extra="$parseopt_extra --stuck-long"
e817e3e8
PH
80
81 eval "$(
cbea86fd 82 echo "$OPTIONS_SPEC" |
e817e3e8
PH
83 git rev-parse --parseopt $parseopt_extra -- "$@" ||
84 echo exit $?
85 )"
bac199b7 86else
7d665f35 87 dashless=$(basename -- "$0" | sed -e 's/-/ /')
bac199b7 88 usage() {
d323c6b6 89 die "$(eval_gettext "usage: \$dashless \$USAGE")"
bac199b7
PH
90 }
91
92 if [ -z "$LONG_USAGE" ]
93 then
d323c6b6 94 LONG_USAGE="$(eval_gettext "usage: \$dashless \$USAGE")"
bac199b7 95 else
d323c6b6 96 LONG_USAGE="$(eval_gettext "usage: \$dashless \$USAGE
bac199b7 97
d323c6b6 98$LONG_USAGE")"
bac199b7
PH
99 fi
100
101 case "$1" in
87182b17 102 -h)
bac199b7 103 echo "$LONG_USAGE"
90a46272 104 case "$0" in *git-legacy-stash) exit 129;; esac
bac199b7
PH
105 exit
106 esac
107fi
d025524d 108
c3e2d189
JH
109# Set the name of the end-user facing command in the reflog when the
110# script may update refs. When GIT_REFLOG_ACTION is already set, this
111# will not overwrite it, so that a scripted Porcelain (e.g. "git
112# rebase") can set it to its own name (e.g. "rebase") and then call
113# another scripted Porcelain (e.g. "git am") and a call to this
114# function in the latter will keep the name of the end-user facing
115# program (e.g. "rebase") in GIT_REFLOG_ACTION, ensuring whatever it
116# does will be record as actions done as part of the end-user facing
117# operation (e.g. "rebase").
118#
119# NOTE NOTE NOTE: consequently, after assigning a specific message to
120# GIT_REFLOG_ACTION when calling a "git" command to record a custom
121# reflog message, do not leave that custom value in GIT_REFLOG_ACTION,
122# after you are done. Other callers of "git" commands that rely on
123# writing the default "program name" in reflog expect the variable to
124# contain the value set by this function.
125#
126# To use a custom reflog message, do either one of these three:
127#
128# (a) use a single-shot export form:
129# GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz" \
130# git command-that-updates-a-ref
131#
132# (b) save the original away and restore:
133# SAVED_ACTION=$GIT_REFLOG_ACTION
134# GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
135# git command-that-updates-a-ref
136# GIT_REFLOG_ACITON=$SAVED_ACTION
137#
138# (c) assign the variable in a subshell:
139# (
140# GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
141# git command-that-updates-a-ref
142# )
f9474132
SP
143set_reflog_action() {
144 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
145 then
146 GIT_REFLOG_ACTION="$*"
147 export GIT_REFLOG_ACTION
148 fi
149}
150
ef0c2abf 151git_editor() {
b4479f07
JN
152 if test -z "${GIT_EDITOR:+set}"
153 then
154 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
155 fi
156
157 eval "$GIT_EDITOR" '"$@"'
ef0c2abf
AR
158}
159
f6dff119
JN
160git_pager() {
161 if test -t 1
162 then
163 GIT_PAGER=$(git var GIT_PAGER)
164 else
165 GIT_PAGER=cat
166 fi
995bc22d
EW
167 for vardef in @@PAGER_ENV@@
168 do
169 var=${vardef%%=*}
170 eval ": \"\${$vardef}\" && export $var"
171 done
f6dff119
JN
172
173 eval "$GIT_PAGER" '"$@"'
174}
175
e1622bfc 176sane_grep () {
71b40103 177 GREP_OPTIONS= LC_ALL=C grep @@SANE_TEXT_GREP@@ "$@"
e1622bfc
JH
178}
179
180sane_egrep () {
71b40103 181 GREP_OPTIONS= LC_ALL=C egrep @@SANE_TEXT_GREP@@ "$@"
e1622bfc
JH
182}
183
4b441f47 184is_bare_repository () {
5be60078 185 git rev-parse --is-bare-repository
4b441f47
JH
186}
187
9fde9401 188cd_to_toplevel () {
91dc602d
SD
189 cdup=$(git rev-parse --show-toplevel) &&
190 cd "$cdup" || {
d323c6b6 191 gettextln "Cannot chdir to \$cdup, the toplevel of the working tree" >&2
91dc602d
SD
192 exit 1
193 }
9fde9401
JH
194}
195
e2eb5273
JH
196require_work_tree_exists () {
197 if test "z$(git rev-parse --is-bare-repository)" != zfalse
198 then
d323c6b6 199 program_name=$0
acefe2be 200 die "$(eval_gettext "fatal: \$program_name cannot be used without a working tree.")"
e2eb5273
JH
201 fi
202}
203
7eff28a9 204require_work_tree () {
d323c6b6
VA
205 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true || {
206 program_name=$0
acefe2be 207 die "$(eval_gettext "fatal: \$program_name cannot be used without a working tree.")"
d323c6b6 208 }
7eff28a9
SP
209}
210
92c62a3f
RR
211require_clean_work_tree () {
212 git rev-parse --verify HEAD >/dev/null || exit 1
213 git update-index -q --ignore-submodules --refresh
214 err=0
215
216 if ! git diff-files --quiet --ignore-submodules
217 then
d323c6b6
VA
218 action=$1
219 case "$action" in
220 rebase)
221 gettextln "Cannot rebase: You have unstaged changes." >&2
222 ;;
223 "rewrite branches")
224 gettextln "Cannot rewrite branches: You have unstaged changes." >&2
225 ;;
226 "pull with rebase")
227 gettextln "Cannot pull with rebase: You have unstaged changes." >&2
228 ;;
229 *)
230 eval_gettextln "Cannot \$action: You have unstaged changes." >&2
231 ;;
232 esac
92c62a3f
RR
233 err=1
234 fi
235
236 if ! git diff-index --cached --quiet --ignore-submodules HEAD --
237 then
d323c6b6 238 if test $err = 0
92c62a3f 239 then
d323c6b6
VA
240 action=$1
241 case "$action" in
242 rebase)
243 gettextln "Cannot rebase: Your index contains uncommitted changes." >&2
244 ;;
245 "pull with rebase")
246 gettextln "Cannot pull with rebase: Your index contains uncommitted changes." >&2
247 ;;
248 *)
249 eval_gettextln "Cannot \$action: Your index contains uncommitted changes." >&2
250 ;;
251 esac
92c62a3f 252 else
d323c6b6 253 gettextln "Additionally, your index contains uncommitted changes." >&2
92c62a3f
RR
254 fi
255 err=1
256 fi
257
d323c6b6 258 if test $err = 1
92c62a3f 259 then
d323c6b6 260 test -n "$2" && echo "$2" >&2
92c62a3f
RR
261 exit 1
262 fi
263}
264
ce80ca56
JK
265# Generate a sed script to parse identities from a commit.
266#
267# Reads the commit from stdin, which should be in raw format (e.g., from
268# cat-file or "--pretty=raw").
269#
270# The first argument specifies the ident line to parse (e.g., "author"), and
271# the second specifies the environment variable to put it in (e.g., "AUTHOR"
272# for "GIT_AUTHOR_*"). Multiple pairs can be given to parse author and
273# committer.
274pick_ident_script () {
275 while test $# -gt 0
276 do
277 lid=$1; shift
278 uid=$1; shift
279 printf '%s' "
280 /^$lid /{
281 s/'/'\\\\''/g
282 h
283 s/^$lid "'\([^<]*\) <[^>]*> .*$/\1/'"
284 s/.*/GIT_${uid}_NAME='&'/p
285
286 g
287 s/^$lid "'[^<]* <\([^>]*\)> .*$/\1/'"
288 s/.*/GIT_${uid}_EMAIL='&'/p
289
290 g
291 s/^$lid "'[^<]* <[^>]*> \(.*\)$/@\1/'"
292 s/.*/GIT_${uid}_DATE='&'/p
293 }
294 "
295 done
296 echo '/^$/q'
297}
298
299# Create a pick-script as above and feed it to sed. Stdout is suitable for
300# feeding to eval.
301parse_ident_from_commit () {
302 LANG=C LC_ALL=C sed -ne "$(pick_ident_script "$@")"
303}
304
305# Parse the author from a commit given as an argument. Stdout is suitable for
306# feeding to eval to set the usual GIT_* ident variables.
0cae2346 307get_author_ident_from_commit () {
0cae2346 308 encoding=$(git config i18n.commitencoding || echo UTF-8)
077b725f 309 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
ce80ca56 310 parse_ident_from_commit author AUTHOR
0cae2346
JS
311}
312
7d750f0e
GB
313# Clear repo-local GIT_* environment variables. Useful when switching to
314# another repository (e.g. when entering a submodule). See also the env
315# list in git_connect()
316clear_local_git_env() {
317 unset $(git rev-parse --local-env-vars)
318}
319
4549162e
KB
320# Generate a virtual base file for a two-file merge. Uses git apply to
321# remove lines from $1 that are not in $2, leaving only common lines.
322create_virtual_base() {
323 sz0=$(wc -c <"$1")
324 @@DIFF@@ -u -La/"$1" -Lb/"$1" "$1" "$2" | git apply --no-add
325 sz1=$(wc -c <"$1")
326
327 # If we do not have enough common material, it is not
328 # worth trying two-file merge using common subsections.
329 expr $sz0 \< $sz1 \* 2 >/dev/null || : >"$1"
330}
331
87bddba9 332
10587ce6 333# Platform specific tweaks to work around some commands
87bddba9
JS
334case $(uname -s) in
335*MINGW*)
336 # Windows has its own (incompatible) sort and find
337 sort () {
338 /usr/bin/sort "$@"
339 }
340 find () {
341 /usr/bin/find "$@"
342 }
be39048a
RJ
343 # git sees Windows-style pwd
344 pwd () {
345 builtin pwd -W
346 }
5e9677cb
PT
347 is_absolute_path () {
348 case "$1" in
349 [/\\]* | [A-Za-z]:*)
350 return 0 ;;
351 esac
352 return 1
353 }
87bddba9 354 ;;
5e9677cb
PT
355*)
356 is_absolute_path () {
357 case "$1" in
358 /*)
359 return 0 ;;
360 esac
361 return 1
362 }
87bddba9 363esac
10587ce6
JH
364
365# Make sure we are in a valid repository of a vintage we understand,
366# if we require to be in a git repository.
1c7e2d23 367git_dir_init () {
10587ce6
JH
368 GIT_DIR=$(git rev-parse --git-dir) || exit
369 if [ -z "$SUBDIRECTORY_OK" ]
370 then
371 test -z "$(git rev-parse --show-cdup)" || {
372 exit=$?
d323c6b6 373 gettextln "You need to run this command from the toplevel of the working tree." >&2
10587ce6
JH
374 exit $exit
375 }
376 fi
377 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
d323c6b6 378 gettextln "Unable to determine absolute path of git directory" >&2
10587ce6
JH
379 exit 1
380 }
01247e02 381 : "${GIT_OBJECT_DIRECTORY="$(git rev-parse --git-path objects)"}"
1c7e2d23
DA
382}
383
384if test -z "$NONGIT_OK"
385then
386 git_dir_init
10587ce6 387fi
bac1ddd0
RR
388
389peel_committish () {
390 case "$1" in
391 :/*)
392 peeltmp=$(git rev-parse --verify "$1") &&
393 git rev-parse --verify "${peeltmp}^0"
394 ;;
395 *)
396 git rev-parse --verify "${1}^0"
397 ;;
398 esac
399}